Competitors

‌‌
This endpoint will provide you with a list of competitors that share some part of the backlink profile with a target website, along with a number of backlink intersections and the rank of every competing website.

checked POST
Pricing

Your account will be charged for each request.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live API call can contain only one task. The maximum number of calls that can be sent simultaneously is limited to 30.

Description of the fields for setting a task:

Field nameTypeDescription
targetstring

domain, subdomain or webpage to get competitor domains for
required field
a domain or a subdomain should be specified without https:// and www.
a page should be specified with absolute URL (including http:// or https://)

limitinteger

the maximum number of returned domains
optional field
default value: 100
maximum value: 1000

offsetinteger

offset in the results array of returned domains
optional field
default value: 0
if you specify the 10 value, the first ten domains in the results array will be omitted and the data will be provided for the successive pages

filtersarray

array of results filtering parameters
optional field
you can add several filters at once (8 filters maximum)
you should set a logical operator and, or between the conditions
the following operators are supported:
regex, not_regex, =, <>, in, not_in, like, not_like, ilike, not_ilike, match, not_match
you can use the % operator with like and not_like to match any string of zero or more characters
example:
["rank",">","100"]

[["target","like","%forbes%"],
"and",
[["rank",">","100"],"or",["intersections",">","5"]]]

The full list of possible filters is available here.

order_byarray

results sorting rules
optional field
you can use the same values as in the filters array to sort the results
possible sorting types:
asc - results will be sorted in the ascending order
desc - results will be sorted in the descending order
you should use a comma to set up a sorting type
example:
["rank,desc"]
note that you can set no more than three sorting rules in a single request
you should use a comma to separate several sorting rules
example:
["intersections,desc","rank,asc"]

main_domainboolean

indicates if only main domain of the target will be included in the search
optional field
if set to true, only the main domain will be included in search;
default value: true

exclude_large_domainsboolean

indicates whether large domain will appear in results
optional field
if set to true, the results from the large domain (google.com, amazon.com, etc.) will be omitted;
default value: true

exclude_internal_backlinksboolean

indicates if internal backlinks from subdomains to the target will be excluded from the results
optional field
if set to true, the results will not include data on internal backlinks from subdomains of the same domain as target
if set to false, internal links will be included in the results
default value: true

rank_scalestring

defines the scale used for calculating and displaying the rank, domain_from_rank, and page_from_rank values
optional field

you can use this parameter to choose whether rank values are presented on a 0–100 or 0–1000 scale

possible values:
one_hundred — rank values are displayed on a 0–100 scale
one_thousand — rank values are displayed on a 0–1000 scale

default value: one_thousand

learn more about how this parameter works and how ranking metrics are calculated in this Help Center article

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response


‌‌‌‌‌‌
As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of the response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        total_countinteger

total number of relevant items in the database

        items_countinteger

number of items in the items array

        itemsarray

items array

            typestring

type of element='backlinks_competitors'n

            targetstring

competitor domain

            rankinteger

domain rank
domain rank across all domains in the database
rank is calculated based on the method for node ranking in a linked database - a principle used in the original Google PageRank algorithm
learn more about the metric and how it is calculated in this help center article

            intersectionsinteger

indicates the number of backlink intersections with the target specified in the POST array

‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/backlinks/competitors/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "target": "dataforseo.com",
        "filters": ["rank", ">", 100],
        "order_by": ["rank,desc"],
        "limit": 5
    }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');
$post_array = array();
// simple way to get a result
$post_array[] = array(
   "target" => "dataforseo.com",
   "filters" => ["rank", ">", 100],
   "order_by" => ["rank,desc"],
   "limit" => 5
);
try {
   // POST /v3/backlinks/competitors/live
   // the full list of possible parameters is available in documentation
   $result = $client->post('/v3/backlinks/competitors/live', $post_array);
   print_r($result);
   // do something with post result
} catch (RestClientException $e) {
   echo "n";
   print "HTTP code: {$e->getHttpCode()}n";
   print "Error code: {$e->getCode()}n";
   print "Message: {$e->getMessage()}n";
   print  $e->getTraceAsString();
   echo "n";
}
$client = null;
?>
const post_array = [];

post_array.push({

        "target": "dataforseo.com",
        "filters": ["rank", ">", 100],
        "order_by": ["rank,desc"],
        "limit": 5
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/backlinks/competitors/live',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from client import RestClient
# You can download this file from here https://api.dataforseo.com/v3/_examples/python/_python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    target="dataforseo.com",
    filters=["rank", ">", 100],
    order_by=["rank,desc"],
    limit=5
)
# POST /v3/backlinks/competitors/live
# the full list of possible parameters is available in documentation
response = client.post("/v3/backlinks/competitors/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task backlinks_competitors_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            // simple way to get a result
            postData.Add(new
            {
                target = "dataforseo.com",
                filters = new object[]
                {
                    new object[] { "rank", ">", 100 }
                },
                order_by = new object[] { "rank,desc" },
                limit = 5
            });
            // POST /v3/backlinks/competitors/live
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/backlinks/competitors/live", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20220720",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "4.9002 sec.",
  "cost": 0.0203,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "07211149-1535-0461-0000-583da4215b2d",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "4.1549 sec.",
      "cost": 0.0203,
      "result_count": 1,
      "path": [
        "v3",
        "backlinks",
        "competitors",
        "live"
      ],
      "data": {
        "api": "backlinks",
        "function": "competitors",
        "target": "dataforseo.com",
        "main_domain": true,
        "exclude_large_domains": true,
        "order_by": [
          "rank,desc"
        ],
        "filters": [
          [
            "rank",
            ">",
            100
          ]
        ],
        "limit": 10
      },
      "result": [
        {
          "total_count": 390,
          "items_count": 10,
          "items": [
            {
              "type": "backlinks_competitors",
              "target": "muskatli.hu",
              "rank": 368,
              "intersections": 4
            },
            {
              "type": "backlinks_competitors",
              "target": "kani.hu",
              "rank": 333,
              "intersections": 2
            },
            {
              "type": "backlinks_competitors",
              "target": "dnsstuff.com",
              "rank": 333,
              "intersections": 2
            },
            {
              "type": "backlinks_competitors",
              "target": "keyboost.co.uk",
              "rank": 310,
              "intersections": 83
            },
            {
              "type": "backlinks_competitors",
              "target": "mapmyuser.com",
              "rank": 302,
              "intersections": 71
            },
            {
              "type": "backlinks_competitors",
              "target": "ahrefs.com",
              "rank": 288,
              "intersections": 257
            },
            {
              "type": "backlinks_competitors",
              "target": "seopageoptimizer.co.uk",
              "rank": 286,
              "intersections": 61
            },
            {
              "type": "backlinks_competitors",
              "target": "linkremoval.net",
              "rank": 285,
              "intersections": 59
            },
            {
              "type": "backlinks_competitors",
              "target": "saijogeorge.com",
              "rank": 282,
              "intersections": 32
            },
            {
              "type": "backlinks_competitors",
              "target": "ipower.eu",
              "rank": 280,
              "intersections": 58
            }
          ]
        }
      ]
    }
  ]
}